import { OperatorFunction, Notification } from 'rxjs';
import { RxNotification, RxNotificationKind } from './model';
export declare function rxMaterialize<T>(): OperatorFunction<T, RxNotification<T>>;
/**
 * @internal
 *
 * @description
 * This function is here to turn RxJS notification kind values into RxNotification kind names.
 * The main reason for the naming is the RxNotification kind values map directly to the default
 * template names (`suspense`, `next`, `error` `complete`) in the directives of the template package
 */
export declare function notificationKindToRxNotificationKind(kind: Notification<unknown>['kind']): RxNotificationKind;
