"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getLatestNodeVersion = void 0;
const http_1 = require("http");
function getLatestNodeVersion(packageName) {
    const DEFAULT_VERSION = 'latest';
    return new Promise((resolve) => {
        return http_1.get(`http://registry.npmjs.org/${packageName}`, (res) => {
            let rawData = '';
            res.on('data', (chunk) => (rawData += chunk));
            res.on('end', () => {
                var _a;
                try {
                    const response = JSON.parse(rawData);
                    const version = (response && response['dist-tags']) || {};
                    resolve((_a = version.latest) !== null && _a !== void 0 ? _a : DEFAULT_VERSION);
                }
                catch (e) {
                    resolve(DEFAULT_VERSION);
                }
            });
        }).on('error', () => resolve(DEFAULT_VERSION));
    });
}
exports.getLatestNodeVersion = getLatestNodeVersion;
