import { IterableDiffers, NgIterable, TemplateRef, TrackByFunction } from '@angular/core';
import { Observable } from 'rxjs';
import { RxListViewComputedContext, RxListViewContext } from './list-view-context';
import { RxListTemplateSettings, RxRenderSettings } from './model';
export interface RxListManager<T> {
    nextStrategy: (config: string | Observable<string>) => void;
    render(changes$: Observable<NgIterable<T>>): Observable<NgIterable<T> | null>;
}
export declare function createListTemplateManager<T, C extends RxListViewContext<T>>(config: {
    renderSettings: RxRenderSettings;
    templateSettings: RxListTemplateSettings<T, C, RxListViewComputedContext> & {
        templateRef: TemplateRef<C>;
    };
    trackBy: TrackByFunction<T>;
    iterableDiffers: IterableDiffers;
}): RxListManager<T>;
