export declare const focusEvents: readonly ["blur", "focus", "focusin", "focusout"];
/**
 * Mouse Events
 * (MouseEvent)[https://developer.mozilla.org/en-US/docs/Web/API/MouseEvent]
 */
export declare const mouseEvents: readonly ["mousedown", "dblclick", "mouseenter", "mouseleave", "mousemove", "mouseout", "mouseover", "mouseup", "click"];
/**
 * Wheel Events
 * (WheelEvent)[https://developer.mozilla.org/en-US/docs/Web/API/WheelEvent]
 */
export declare const wheelEvents: readonly ["wheel", "mousewheel"];
export declare const inputEvents: readonly ["input", "invalid", "change", "reset", "select", "submit"];
/**
 * @deprecated
 */
export declare const formControlsEvents: readonly ["input", "invalid", "change", "reset", "select", "submit"];
export declare const keyboardEvents: readonly ["keydown", "keypress", "keyup"];
export declare const vrEvents: readonly ["vrdisplayactivate", "vrdisplayblur", "vrdisplayconnect", "vrdisplaydeactivate", "vrdisplaydisconnect", "vrdisplayfocus", "vrdisplaypointerrestricted", "vrdisplaypointerunrestricted", "vrdisplaypresentchange"];
export declare const mSGestureEvents: readonly ["MSGestureChange", "MSGestureDoubleTap", "MSGestureEnd", "MSGestureHold", "MSGestureStart", "MSGestureTap", "MSInertiaStart", "MSPointerCancel", "MSPointerDown", "MSPointerEnter", "MSPointerLeave", "MSPointerMove", "MSPointerOut", "MSPointerOver", "MSPointerUp"];
export declare const printEvents: readonly ["afterprint", "beforeprint"];
export declare const networkEvents: readonly ["offline", "online"];
export declare const audioEvents: readonly ["canplay", "canplaythrough", "pause", "play", "playing", "volumechange"];
export declare const compositionEvents: readonly ["compositionstart", "compositionupdate", "compositionend"];
/**
 * Touch Events
 * [PointerEvent](https://developer.mozilla.org/en-US/docs/Web/API/PointerEvent)
 * [TouchEvent](https://developer.mozilla.org/en-US/docs/Web/API/TouchEvent)
 */
export declare const touchEvents: readonly ["pointerover", "pointerenter", "pointerdown", "pointermove", "pointerup", "pointercancel", "pointerout", "pointerleave", "gotpointercapture", "lostpointercapture", "pointerup", "touchstart", "touchend", "touchmove", "touchcancel", "drag", "dragend", "dragexit", "dragenter", "dragleave", "dragover", "dragstart", "drop"];
export declare const globalEvents: readonly ["contextmenu", "resize", "scroll", "abort", "load", "loadeddata", "loadedmetadata", "loadstart", "unload", "error"];
export declare const websocketEvents: readonly ["close", "error", "message", "open"];
/**
 * Basic XHR Events
 * [Load](https://developer.mozilla.org/en-US/docs/Web/API/XMLHttpRequest/load_event)
 * [Error](https://developer.mozilla.org/en-US/docs/Web/API/XMLHttpRequest/error_event)
 * There are more events you may want to unpatch https://developer.mozilla.org/en-US/docs/Web/API/XMLHttpRequest
 */
export declare const xhrEvents: readonly ["load", "error"];
export declare const windowEvents: readonly ["compassneedscalibration", "durationchange", "emptied", "ended", "orientationchange", "ratechange", "seeked", "seeking", "stalled", "suspend", "timeupdate", "waiting"];
/**
 * All Events combined
 */
export declare const allEvents: ("blur" | "focus" | "focusin" | "focusout" | "mousedown" | "dblclick" | "mouseenter" | "mouseleave" | "mousemove" | "mouseout" | "mouseover" | "mouseup" | "click" | "wheel" | "mousewheel" | "input" | "invalid" | "change" | "reset" | "select" | "submit" | "keydown" | "keypress" | "keyup" | "vrdisplayactivate" | "vrdisplayblur" | "vrdisplayconnect" | "vrdisplaydeactivate" | "vrdisplaydisconnect" | "vrdisplayfocus" | "vrdisplaypointerrestricted" | "vrdisplaypointerunrestricted" | "vrdisplaypresentchange" | "MSGestureChange" | "MSGestureDoubleTap" | "MSGestureEnd" | "MSGestureHold" | "MSGestureStart" | "MSGestureTap" | "MSInertiaStart" | "MSPointerCancel" | "MSPointerDown" | "MSPointerEnter" | "MSPointerLeave" | "MSPointerMove" | "MSPointerOut" | "MSPointerOver" | "MSPointerUp" | "afterprint" | "beforeprint" | "offline" | "online" | "canplay" | "canplaythrough" | "pause" | "play" | "playing" | "volumechange" | "compositionstart" | "compositionupdate" | "compositionend" | "pointerover" | "pointerenter" | "pointerdown" | "pointermove" | "pointerup" | "pointercancel" | "pointerout" | "pointerleave" | "gotpointercapture" | "lostpointercapture" | "touchstart" | "touchend" | "touchmove" | "touchcancel" | "drag" | "dragend" | "dragexit" | "dragenter" | "dragleave" | "dragover" | "dragstart" | "drop" | "contextmenu" | "resize" | "scroll" | "abort" | "load" | "loadeddata" | "loadedmetadata" | "loadstart" | "unload" | "error" | "close" | "message" | "open" | "compassneedscalibration" | "durationchange" | "emptied" | "ended" | "orientationchange" | "ratechange" | "seeked" | "seeking" | "stalled" | "suspend" | "timeupdate" | "waiting")[];
